"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const react_testing_library_1 = require("react-testing-library");
require("jest-dom/extend-expect");
const example_plug_1 = require("../lib/utils/example-plug");
const example_store_1 = require("../lib/utils/example-store");
describe('Plug', () => {
    afterEach(react_testing_library_1.cleanup);
    it('Renders', (done) => __awaiter(this, void 0, void 0, function* () {
        const { getByTestId } = react_testing_library_1.render(<example_plug_1.PluggedTestComponent name="Test Testersson"/>);
        const nameNode = yield react_testing_library_1.waitForElement(() => getByTestId('name'));
        const totalNode = yield react_testing_library_1.waitForElement(() => getByTestId('total'));
        const changedNode = yield react_testing_library_1.waitForElement(() => getByTestId('changed'));
        expect(nameNode).toHaveTextContent('Test Testersson');
        expect(totalNode).toHaveTextContent('Total: 0');
        expect(changedNode).toHaveTextContent(`The store wasn't changed`);
        done();
    }));
    it('Renders with new State', (done) => __awaiter(this, void 0, void 0, function* () {
        example_store_1.setTotal10ChangedTrue();
        const { getByTestId } = react_testing_library_1.render(<example_plug_1.PluggedTestComponent name="Test Testersson"/>);
        const nameNode = yield react_testing_library_1.waitForElement(() => getByTestId('name'));
        const totalNode = yield react_testing_library_1.waitForElement(() => getByTestId('total'));
        const changedNode = yield react_testing_library_1.waitForElement(() => getByTestId('changed'));
        expect(nameNode).toHaveTextContent('Test Testersson');
        expect(totalNode).toHaveTextContent('Total: 10');
        expect(changedNode).toHaveTextContent(`The store was changed`);
        done();
    }));
});
