"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const lib_1 = require("../../lib");
const operators_1 = require("rxjs/operators");
const rxjs_1 = require("rxjs");
const example_store_1 = require("./example-store");
const TestComponent = (props) => {
    const { total, changed, name } = props;
    return (<div>
      <h1 data-testid="name">{name}</h1>
      <p data-testid="total">Total: {total}</p>
      <p data-testid="changed">The store was{changed ? '' : `n't`} changed.</p>
    </div>);
};
const stream = (props) => {
    return rxjs_1.of(props).pipe(operators_1.combineLatest(example_store_1.state$), operators_1.map(([props, state]) => {
        const data = Object.assign({ name: props.name }, state);
        return data;
    }));
};
const PluggedTestComponent = lib_1.plug(stream)(TestComponent);
exports.PluggedTestComponent = PluggedTestComponent;
